'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _d2 = require('d3');

var d3 = _interopRequireWildcard(_d2);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _reactMeasure = require('react-measure');

var _theme = require('./theme');

var _theme2 = _interopRequireDefault(_theme);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LEGEND_HEIGHT = 50;
var GENE_SLOT_HEIGHT = 25;
var GENE_TRANSCRIPT_HEIGHT = 5;
var GENE_TRANSCRIPT_OFFSET = 2;
var GENE_BACKDROP_PADDING = 2;
var GENE_TRACK_PADDING = 5;
var STUDY_SLOT_HEIGHT = 50;
var STUDY_TEXT_MAX_WIDTH = 200;
var TAG_VARIANT_BLOCK_SLOT_HEIGHT = 10;
var VARIANT_TRACK_HEIGHT = 7;
var CONNECTOR_TRACK_HEIGHT = 80;
var CHAR_WIDTH = 8; // TODO: base on font-size
var CHAR_HEIGHT = 12;
var HEIGHT_DEFAULT = 400;
var SCALE_FACTOR = 2;
var HIDDEN_TYPE_MAP = {
  gene: 1,
  tagVariantBlock: 2,
  indexVariant: 3,
  study: 4
};
var HIDDEN_TYPE_MAP_INVERSE = {};
Object.keys(HIDDEN_TYPE_MAP).forEach(function (k) {
  return HIDDEN_TYPE_MAP_INVERSE[HIDDEN_TYPE_MAP[k]] = k;
});
var ENTITY_WIDTH = 34;
var ENTITY_RADIUS = 13;

var color = function color(d, noSelectedEntities) {
  return d.selected ? _theme2.default.gecko.colorSelected : !noSelectedEntities && d.chained ? _theme2.default.gecko.colorChained : _theme2.default.gecko.color;
};
var tagVariantBlockColor = function tagVariantBlockColor(d, noSelectedEntities) {
  return d.expansionType === 'fm' ? d.selected ? _theme2.default.gecko.finemappingColorSelected : !noSelectedEntities && d.chained ? _theme2.default.gecko.finemappingColorChained : _theme2.default.gecko.finemappingColor : d.selected ? _theme2.default.gecko.colorSelected : !noSelectedEntities && d.chained ? _theme2.default.gecko.colorChained : _theme2.default.gecko.color;
};
var backgroundColor = function backgroundColor(d, noSelectedEntities) {
  return d.selected ? _theme2.default.gecko.backgroundColorSelected : !noSelectedEntities && d.chained ? _theme2.default.gecko.backgroundColorChained : _theme2.default.gecko.backgroundColor;
};
var connectorColor = function connectorColor(d, noSelectedEntities) {
  return d.expansionType === 'fm' ? d.selected ? _theme2.default.gecko.finemappingConnectorColorSelected : !noSelectedEntities && d.chained ? _theme2.default.gecko.finemappingConnectorColorChained : _theme2.default.gecko.finemappingConnectorColor : d.selected ? _theme2.default.gecko.connectorColorSelected : !noSelectedEntities && d.chained ? _theme2.default.gecko.connectorColorChained : _theme2.default.gecko.connectorColor;
};

var wrapText = function wrapText(text, maxLineWidth, measure) {
  var lines = [];
  var spaceWidth = measure(' ');
  var wordsLeft = text.split(' ');
  var currentLine = '';
  var currentLineWidth = 0;
  var currentMaxLineWidth = 0;
  while (wordsLeft.length > 0) {
    var word = wordsLeft.shift();
    var wordWidth = measure(word);
    if (currentLineWidth + wordWidth < maxLineWidth) {
      // word fits on current line
      currentLine += (currentLineWidth > 0 ? ' ' : '') + word;
      currentLineWidth += (currentLineWidth > 0 ? spaceWidth : 0) + wordWidth;
      currentMaxLineWidth = currentLineWidth > currentMaxLineWidth ? currentLineWidth : currentMaxLineWidth;
    } else {
      if (wordWidth < maxLineWidth) {
        // word doesn't fit on line, but fits on next
        lines.push(currentLine);
        currentLine = word;
        currentLineWidth = wordWidth;
        currentMaxLineWidth = currentLineWidth > currentMaxLineWidth ? currentLineWidth : currentMaxLineWidth;
      } else {
        // word doesn't fit on a single line
        // TODO: wrap single word
        lines.push(currentLine);
        currentLine = word;
        currentLineWidth = wordWidth;
        currentMaxLineWidth = currentLineWidth > currentMaxLineWidth ? currentLineWidth : currentMaxLineWidth;
      }
    }
    // last word?
    if (wordsLeft.length === 0) {
      lines.push(currentLine);
    }
  }
  return {
    lines: lines,
    width: currentMaxLineWidth
  };
};

var Gecko = function (_React$Component) {
  _inherits(Gecko, _React$Component);

  function Gecko(props) {
    _classCallCheck(this, Gecko);

    var _this = _possibleConstructorReturn(this, (Gecko.__proto__ || Object.getPrototypeOf(Gecko)).call(this, props));

    _this.canvasRef = _react2.default.createRef();
    _this.hiddenCanvasRef = _react2.default.createRef();
    return _this;
  }

  _createClass(Gecko, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this._render();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this._render();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var measureRef = this.props.measureRef;

      var _dimensions2 = this._dimensions(),
          width = _dimensions2.width,
          height = _dimensions2.height;

      return _react2.default.createElement(
        'div',
        {
          ref: measureRef,
          style: {
            width: '100%',
            height: height + 'px',
            position: 'relative'
          }
        },
        _react2.default.createElement('canvas', {
          width: width ? width * SCALE_FACTOR : 0,
          height: height * SCALE_FACTOR,
          style: {
            width: width + 'px',
            height: height + 'px',
            pointerEvents: 'none',
            position: 'absolute',
            top: 0,
            left: 0
          },
          ref: function ref(node) {
            return _this2.canvasRef = node;
          }
        }),
        _react2.default.createElement('canvas', {
          width: width ? width * SCALE_FACTOR : 0,
          height: height * SCALE_FACTOR,
          style: {
            width: width + 'px',
            height: height + 'px',
            position: 'absolute',
            top: 0,
            left: 0,
            imageRendering: 'pixelated',
            opacity: 0
          },
          ref: function ref(node) {
            return _this2.hiddenCanvasRef = node;
          }
        })
      );
    }
  }, {
    key: '_width',
    value: function _width() {
      var contentRect = this.props.contentRect;
      var width = contentRect.bounds.width;

      return width;
    }
  }, {
    key: '_height',
    value: function _height() {
      var _props = this.props,
          data = _props.data,
          start = _props.start,
          end = _props.end;

      var width = this._width();
      if (this._bail(data, width)) {
        return HEIGHT_DEFAULT;
      }
      var scalePosition = d3.scaleLinear().domain([start, end]).range([0, width]);

      var _geneSlots2 = this._geneSlots(data.genes, scalePosition),
          geneSlots = _geneSlots2.slots;

      var _tagVariantBlocksSlot = this._tagVariantBlocksSlots(data.tagVariantBlocks, scalePosition),
          tagVariantBlockSlots = _tagVariantBlocksSlot.slots;

      var canvas = this.canvasRef;
      var context = canvas.getContext('2d');
      var studiesWithWrappedLabels = this._studiesWithWrappedLabels(data.studies, context);

      var _studyScaleY2 = this._studyScaleY(studiesWithWrappedLabels, width),
          studiesTrackHeight = _studyScaleY2.trackHeight;

      var trackConfig = this._trackConfig(geneSlots.length, tagVariantBlockSlots.length, studiesTrackHeight ? studiesTrackHeight : 0);
      return trackConfig.height;
    }
  }, {
    key: '_dimensions',
    value: function _dimensions() {
      var width = this._width();
      var height = this._height();
      return { width: width, height: height };
    }
  }, {
    key: '_bail',
    value: function _bail(data, width) {
      return !width || !data || !data.tagVariantBlocks || !data.genes || !data.indexVariants || !data.geneIndexVariantStudies || !data.studies;
    }
  }, {
    key: '_render',
    value: function _render() {
      var _props2 = this.props,
          rawData = _props2.data,
          start = _props2.start,
          end = _props2.end,
          showGeneVerticals = _props2.showGeneVerticals,
          handleClick = _props2.handleClick,
          handleMousemove = _props2.handleMousemove,
          selectedGenes = _props2.selectedGenes,
          selectedTagVariantBlocks = _props2.selectedTagVariantBlocks,
          selectedIndexVariants = _props2.selectedIndexVariants,
          selectedStudies = _props2.selectedStudies;

      var _generateHiddenColors2 = this._generateHiddenColors(rawData),
          colorMap = _generateHiddenColors2.colorMap,
          data = _objectWithoutProperties(_generateHiddenColors2, ['colorMap']);

      var noSelectedEntities = !selectedGenes && !selectedTagVariantBlocks && !selectedIndexVariants && !selectedStudies;

      var width = this._width();
      if (this._bail(data, width)) {
        return null;
      }

      var canvas = this.canvasRef;
      var context = canvas.getContext('2d');
      var hiddenCanvas = this.hiddenCanvasRef;
      var hiddenContext = hiddenCanvas.getContext('2d');

      d3.select(hiddenCanvas).on('mousemove', function () {
        var point = d3.mouse(this);

        var _hiddenContext$getIma = _slicedToArray(hiddenContext.getImageData(Math.round(point[0]) * SCALE_FACTOR, Math.round(point[1]) * SCALE_FACTOR, 1, 1).data, 4),
            r = _hiddenContext$getIma[0],
            g = _hiddenContext$getIma[1],
            b = _hiddenContext$getIma[2],
            a = _hiddenContext$getIma[3];

        var color = 'rgb(' + r + ',' + g + ',' + b + ',' + a + ')';
        var item = colorMap[color];
        if (item) {
          var type = HIDDEN_TYPE_MAP_INVERSE[r >> 4];
          d3.select(hiddenCanvas).style('cursor', 'pointer');
          handleMousemove(item, type, point);
        } else {
          d3.select(hiddenCanvas).style('cursor', 'auto');
        }
      });

      d3.select(hiddenCanvas).on('click', function () {
        var point = d3.mouse(this);

        var _hiddenContext$getIma2 = _slicedToArray(hiddenContext.getImageData(Math.round(point[0]) * SCALE_FACTOR, Math.round(point[1]) * SCALE_FACTOR, 1, 1).data, 4),
            r = _hiddenContext$getIma2[0],
            g = _hiddenContext$getIma2[1],
            b = _hiddenContext$getIma2[2],
            a = _hiddenContext$getIma2[3];

        var color = 'rgb(' + r + ',' + g + ',' + b + ',' + a + ')';
        var item = colorMap[color];
        if (item) {
          var type = HIDDEN_TYPE_MAP_INVERSE[r >> 4];
          handleClick(item, type, point);
        }
      });

      var scalePosition = d3.scaleLinear().domain([start, end]).range([0, width]);

      var _geneSlots3 = this._geneSlots(data.genes, scalePosition),
          geneSlots = _geneSlots3.slots,
          genesWithSlots = _geneSlots3.genesWithSlots;

      var _tagVariantBlocksSlot2 = this._tagVariantBlocksSlots(data.tagVariantBlocks, scalePosition),
          tagVariantBlockSlots = _tagVariantBlocksSlot2.slots,
          tagVariantBlocksWithSlots = _tagVariantBlocksSlot2.tagVariantBlocksWithSlots;

      var scaleStudyX = this._studyScaleX(data.studies, width);
      var studiesWithWrappedLabels = this._studiesWithWrappedLabels(data.studies, context);

      var _studyScaleY3 = this._studyScaleY(studiesWithWrappedLabels, width),
          scaleStudyY = _studyScaleY3.scaleStudyY,
          studiesTrackHeight = _studyScaleY3.trackHeight;

      var trackConfig = this._trackConfig(geneSlots.length, tagVariantBlockSlots.length, studiesTrackHeight);

      context.save();
      context.imageSmoothingEnabled = true;
      context.scale(SCALE_FACTOR, SCALE_FACTOR);
      context.clearRect(0, 0, width, trackConfig.height);

      hiddenContext.save();
      hiddenContext.scale(SCALE_FACTOR, SCALE_FACTOR);
      hiddenContext.imageSmoothingEnabled = false;
      hiddenContext.webkitImageSmoothingEnabled = false;
      hiddenContext.mozImageSmoothingEnabled = false;
      hiddenContext.msImageSmoothingEnabled = false;
      hiddenContext.oImageSmoothingEnabled = false;
      hiddenContext.clearRect(0, 0, width, trackConfig.height);

      this._renderLegend(context, width);
      this._renderGenes(context, hiddenContext, scalePosition, trackConfig.genes, genesWithSlots, noSelectedEntities, showGeneVerticals);
      this._renderTagVariantBlocks(context, hiddenContext, scalePosition, trackConfig.tagVariantBlocks, tagVariantBlocksWithSlots, noSelectedEntities);
      this._renderIndexVariants(context, hiddenContext, scalePosition, trackConfig.indexVariants, data.indexVariants, noSelectedEntities);
      this._renderStudies(context, hiddenContext, scaleStudyX, scaleStudyY, trackConfig.studies, data.studies, noSelectedEntities);
      this._renderGeneIndexVariantStudies(context, scalePosition, scaleStudyX, trackConfig.geneTagVariants, trackConfig.tagVariantIndexVariants, trackConfig.indexVariantStudies, data.geneIndexVariantStudies, noSelectedEntities);
      this._renderEntities(context, trackConfig, selectedGenes, selectedTagVariantBlocks, selectedIndexVariants, selectedStudies);

      context.restore();
      hiddenContext.restore();
    }
  }, {
    key: '_renderEntities',
    value: function _renderEntities(context, trackConfig, selectedGenes, selectedTagVariantBlocks, selectedIndexVariants, selectedStudies) {
      context.save();
      context.textAlign = 'center';
      context.textBaseline = 'middle';
      context.lineWidth = 2;

      var x = ENTITY_WIDTH / 2;
      var fill = _theme2.default.grey[300];
      var text = _theme2.default.grey[500];
      var fillFixed = _theme2.default.primary;
      var textFixed = 'white';

      // G
      var yG = trackConfig.genes.top + ENTITY_WIDTH / 2;
      context.fillStyle = selectedGenes ? fillFixed : fill;
      context.strokeStyle = selectedGenes ? fillFixed : text;
      context.beginPath();
      context.arc(x, yG, ENTITY_RADIUS, 0, 2 * Math.PI);
      context.fill();
      context.stroke();
      context.fillStyle = selectedGenes ? textFixed : text;
      context.font = 'bold 12px sans-serif';
      context.fillText('G', x, yG);

      // TV
      var yTV = (trackConfig.tagVariantBlocks.top + trackConfig.tagVariantBlocks.bottom) / 2;
      context.fillStyle = selectedTagVariantBlocks ? fillFixed : fill;
      context.strokeStyle = selectedTagVariantBlocks ? fillFixed : text;
      context.beginPath();
      context.arc(x, yTV, ENTITY_RADIUS, 0, 2 * Math.PI);
      context.fill();
      context.stroke();
      context.fillStyle = selectedTagVariantBlocks ? textFixed : text;
      context.font = 'bold 12px sans-serif';
      context.fillText('V', x - 2, yTV);
      context.font = 'bold 9px sans-serif';
      context.fillText('T', x + 4, yTV + 5);

      // IV
      var yIV = (trackConfig.indexVariants.top + trackConfig.indexVariants.bottom) / 2;
      context.fillStyle = selectedIndexVariants ? fillFixed : fill;
      context.strokeStyle = selectedIndexVariants ? fillFixed : text;
      context.beginPath();
      context.arc(x, yIV, ENTITY_RADIUS, 0, 2 * Math.PI);
      context.fill();
      context.stroke();
      context.fillStyle = selectedIndexVariants ? textFixed : text;
      context.font = 'bold 12px sans-serif';
      context.fillText('V', x - 2, yIV);
      context.font = 'bold 9px sans-serif';
      context.fillText('L', x + 4, yIV + 5);

      // S
      var yS = trackConfig.studies.top + ENTITY_WIDTH / 2;
      context.fillStyle = selectedStudies ? fillFixed : fill;
      context.strokeStyle = selectedStudies ? fillFixed : text;
      context.beginPath();
      context.arc(x, yS, ENTITY_RADIUS, 0, 2 * Math.PI);
      context.fill();
      context.stroke();
      context.fillStyle = selectedStudies ? textFixed : text;
      context.font = 'bold 12px sans-serif';
      context.fillText('S', x, yS);

      context.restore();
    }
  }, {
    key: '_renderLegend',
    value: function _renderLegend(context, width) {
      context.save();

      context.textAlign = 'start';
      context.textBaseline = 'middle';
      context.font = '12px sans-serif';

      var side = 10;
      var label = LEGEND_HEIGHT / 3;
      var middle = LEGEND_HEIGHT * 2 / 3;
      var top = middle - side / 2;
      var textOffset = 12;
      var itemOffset = 55;
      var groupOffset = 165;
      var textColor = _theme2.default.gecko.color;

      var xDefaultEntity = top;
      var xDefaultConnector = xDefaultEntity + itemOffset;
      var xDefaultConnectorFinemapping = xDefaultConnector + itemOffset;
      var xSelectedEntity = xDefaultConnectorFinemapping + groupOffset;
      var xChainedEntity = xSelectedEntity + groupOffset;
      var xChainedConnector = xChainedEntity + itemOffset;
      var xChainedConnectorFinemapping = xChainedConnector + itemOffset;

      // background
      context.fillStyle = _theme2.default.gecko.legend;
      context.fillRect(0, 0, width, LEGEND_HEIGHT);

      // default entity
      context.fillStyle = _theme2.default.gecko.color;
      context.fillRect(xDefaultEntity, top, side, side);
      context.fillStyle = textColor;
      context.fillText('entity', xDefaultEntity + textOffset, middle);
      // default connector
      context.fillStyle = _theme2.default.gecko.connectorColor;
      context.fillRect(xDefaultConnector, middle - 1, side, 2);
      context.fillStyle = textColor;
      context.fillText('link', xDefaultConnector + textOffset, middle);
      // default connector finemapping
      context.fillStyle = _theme2.default.gecko.finemappingConnectorColor;
      context.fillRect(xDefaultConnectorFinemapping, middle - 1, side, 2);
      context.fillStyle = textColor;
      context.fillText('link (finemapping)', xDefaultConnectorFinemapping + textOffset, middle);

      // selected entity
      context.fillStyle = _theme2.default.gecko.colorSelected;
      context.fillRect(xSelectedEntity, top, side, side);
      context.fillStyle = textColor;
      context.fillText('entity', xSelectedEntity + textOffset, middle);

      // chained entity
      context.fillStyle = _theme2.default.gecko.colorChained;
      context.fillRect(xChainedEntity, top, side, side);
      context.fillStyle = textColor;
      context.fillText('entity', xChainedEntity + textOffset, middle);
      // chained connector
      context.fillStyle = _theme2.default.gecko.connectorColorChained;
      context.fillRect(xChainedConnector, middle - 1, side, 2);
      context.fillStyle = textColor;
      context.fillText('link', xChainedConnector + textOffset, middle);
      // chained connector finemapping
      context.fillStyle = _theme2.default.gecko.finemappingConnectorColorChained;
      context.fillRect(xChainedConnectorFinemapping, middle - 1, side, 2);
      context.fillStyle = textColor;
      context.fillText('link (finemapping)', xChainedConnectorFinemapping + textOffset, middle);

      // labels
      context.textAlign = 'center';
      context.font = 'bold 12px sans-serif';
      context.fillText('unselected', xDefaultConnector + textOffset * 2, label);
      context.fillText('selected', xSelectedEntity + textOffset * 2, label);
      context.fillText('connected', xChainedConnector + textOffset * 2, label);

      context.restore();
    }
  }, {
    key: '_renderGenes',
    value: function _renderGenes(context, hiddenContext, scaleX, track, data, noSelectedEntities, showGeneVerticals) {
      context.save();
      context.translate(0, track.top + GENE_TRACK_PADDING);
      hiddenContext.save();
      hiddenContext.translate(0, track.top + GENE_TRACK_PADDING);

      // verticals
      // const verticals =
      //   noSelectedEntities || showGeneVerticals
      //     ? data
      //     : data.filter(d => d.chained);
      var verticals = data.filter(function (d) {
        return d.chained;
      });
      verticals.forEach(function (d) {
        context.strokeStyle = color(d, noSelectedEntities);
        context.beginPath();
        context.moveTo(scaleX(d.tss), d.slotIndex * GENE_SLOT_HEIGHT);
        context.lineTo(scaleX(d.tss), track.height - GENE_TRACK_PADDING);
        context.stroke();
      });

      // genes
      data.forEach(function (d) {
        var label = d.start === d.tss ? d.symbol + '>' : '<' + d.symbol;
        var textWidth = context.measureText(label).width;

        var backdropX = scaleX(d.start) - GENE_BACKDROP_PADDING;
        var backdropY = d.slotIndex * GENE_SLOT_HEIGHT + GENE_TRANSCRIPT_OFFSET - GENE_BACKDROP_PADDING;
        var backdropWidth = Math.max(textWidth, scaleX(d.end) - scaleX(d.start)) + GENE_BACKDROP_PADDING * 2;
        var backdropHeight = GENE_TRANSCRIPT_HEIGHT + CHAR_HEIGHT + GENE_BACKDROP_PADDING * 2;
        var spitY = d.slotIndex * GENE_SLOT_HEIGHT + GENE_TRANSCRIPT_OFFSET + GENE_TRANSCRIPT_HEIGHT / 2;

        // picker
        hiddenContext.fillStyle = d.hiddenColor;
        hiddenContext.fillRect(backdropX, backdropY, backdropWidth, backdropHeight);

        // backdrop
        context.fillStyle = backgroundColor(d, noSelectedEntities);
        context.strokeStyle = color(d, noSelectedEntities);
        context.fillRect(backdropX, backdropY, backdropWidth, backdropHeight);
        context.strokeRect(backdropX, backdropY, backdropWidth, backdropHeight);

        // spit
        context.beginPath();
        context.moveTo(scaleX(d.start), spitY);
        context.lineTo(scaleX(d.end), spitY);
        context.stroke();

        // exons
        d.exons.forEach(function (e) {
          var exonX = scaleX(e[[0]]);
          var exonY = d.slotIndex * GENE_SLOT_HEIGHT + GENE_TRANSCRIPT_OFFSET;
          var exonWidth = scaleX(e[[1]]) - exonX;
          var exonHeight = GENE_TRANSCRIPT_HEIGHT;
          context.fillRect(exonX, exonY, exonWidth, exonHeight);
          context.strokeRect(exonX, exonY, exonWidth, exonHeight);
        });

        // label
        var labelX = scaleX(d.start);
        var labelY = d.slotIndex * GENE_SLOT_HEIGHT + GENE_TRANSCRIPT_OFFSET * 2 + GENE_TRANSCRIPT_HEIGHT;
        context.textBaseline = 'hanging';
        context.fillStyle = color(d, noSelectedEntities);
        context.fillText(label, labelX, labelY);
      });

      context.restore();
      hiddenContext.restore();
    }
  }, {
    key: '_generateHiddenColors',
    value: function _generateHiddenColors(data) {
      var _this3 = this;

      var genes = data.genes,
          tagVariantBlocks = data.tagVariantBlocks,
          indexVariants = data.indexVariants,
          studies = data.studies,
          geneIndexVariantStudies = data.geneIndexVariantStudies;

      var colorMap = {};
      var genesWithHiddenColor = genes.map(function (d, i) {
        var color = _this3._hiddenColor(i, 'gene');
        colorMap[color] = d;
        return _extends({}, d, { hiddenColor: color });
      });
      var tagVariantBlocksWithHiddenColor = tagVariantBlocks.map(function (d, i) {
        var color = _this3._hiddenColor(i, 'tagVariantBlock');
        colorMap[color] = d;
        return _extends({}, d, { hiddenColor: color });
      });
      var indexVariantsWithHiddenColor = indexVariants.map(function (d, i) {
        var color = _this3._hiddenColor(i, 'indexVariant');
        colorMap[color] = d;
        return _extends({}, d, { hiddenColor: color });
      });
      var studiesWithHiddenColor = studies.map(function (d, i) {
        var color = _this3._hiddenColor(i, 'study');
        colorMap[color] = d;
        return _extends({}, d, { hiddenColor: color });
      });
      return {
        colorMap: colorMap,
        genes: genesWithHiddenColor,
        tagVariantBlocks: tagVariantBlocksWithHiddenColor,
        indexVariants: indexVariantsWithHiddenColor,
        studies: studiesWithHiddenColor,
        geneIndexVariantStudies: geneIndexVariantStudies
      };
    }
  }, {
    key: '_hiddenColor',
    value: function _hiddenColor(entityId, type) {
      var typeId = HIDDEN_TYPE_MAP[type];
      var r = (typeId << 4) + Math.floor(entityId / 65536) % 256;
      var g = Math.floor(entityId / 256) % 256;
      var b = entityId % 256;
      return 'rgb(' + r + ',' + g + ',' + b + ',255)';
    }
  }, {
    key: '_renderTagVariantBlocks',
    value: function _renderTagVariantBlocks(context, hiddenContext, scaleX, track, data, noSelectedEntities) {
      context.save();
      hiddenContext.save();

      // picker
      hiddenContext.translate(0, track.top);
      data.forEach(function (d) {
        var s = Math.round(scaleX(d.tagVariantsStart));
        var e = Math.round(scaleX(d.tagVariantsEnd));
        var isThin = e - s < 2;
        hiddenContext.fillStyle = d.hiddenColor;
        hiddenContext.fillRect(isThin ? s - 1 : s, (0.5 + d.slotIndex) * TAG_VARIANT_BLOCK_SLOT_HEIGHT - 0.5 * VARIANT_TRACK_HEIGHT, isThin ? 2 : e - s, VARIANT_TRACK_HEIGHT);
      });

      // boundaries
      context.fillStyle = _theme2.default.track.background;
      context.translate(0, track.top);
      context.fillRect(0, 0, scaleX.range()[1] - scaleX.range()[0], 1);
      context.fillRect(0, track.height - 1, scaleX.range()[1] - scaleX.range()[0], 1);

      // tag variants
      context.lineWidth = 2;
      data.forEach(function (d) {
        var s = Math.round(scaleX(d.tagVariantsStart));
        var e = Math.round(scaleX(d.tagVariantsEnd));
        var isThin = e - s < 2;
        context.fillStyle = tagVariantBlockColor(d, noSelectedEntities); // color(d, noSelectedEntities);
        context.fillRect(isThin ? s - 1 : s, (0.5 + d.slotIndex) * TAG_VARIANT_BLOCK_SLOT_HEIGHT - 0.5 * VARIANT_TRACK_HEIGHT, isThin ? 2 : e - s, VARIANT_TRACK_HEIGHT);
      });

      context.restore();
      hiddenContext.restore();
    }
  }, {
    key: '_renderIndexVariants',
    value: function _renderIndexVariants(context, hiddenContext, scaleX, track, data, noSelectedEntities) {
      context.save();
      hiddenContext.save();

      // picker
      hiddenContext.translate(0, track.top);
      data.forEach(function (d) {
        hiddenContext.fillStyle = d.hiddenColor;
        hiddenContext.fillRect(Math.round(scaleX(d.position)) - 1, 0, 2, Math.round(track.height));
      });

      // backdrop
      context.fillStyle = _theme2.default.track.background;
      context.translate(0, track.top);
      context.fillRect(0, 0, scaleX.range()[1] - scaleX.range()[0], track.height);

      // index variants
      context.lineWidth = 2;
      data.forEach(function (d) {
        context.strokeStyle = color(d, noSelectedEntities);
        context.beginPath();
        context.moveTo(scaleX(d.position), 0);
        context.lineTo(scaleX(d.position), track.height);
        context.stroke();
      });

      context.restore();
      hiddenContext.restore();
    }
  }, {
    key: '_renderStudies',
    value: function _renderStudies(context, hiddenContext, scaleX, scaleY, track, data, noSelectedEntities) {
      var _this4 = this;

      context.save();
      context.translate(0, track.top);
      hiddenContext.save();
      hiddenContext.translate(0, track.top);

      // verticals
      data.forEach(function (d) {
        context.strokeStyle = color(d, noSelectedEntities);
        context.beginPath();
        context.moveTo(scaleX(d.studyId), 0);
        context.lineTo(scaleX(d.studyId), scaleY(d.studyId));
        context.stroke();
      });

      // studies
      context.textBaseline = 'hanging';
      context.textAlign = 'center';
      data.forEach(function (d) {
        var label = d.traitReported + (d.pubAuthor && d.pubDate ? ' (' + d.pubAuthor + ' ' + new Date(d.pubDate).getFullYear() + ')' : '');

        var _wrapText2 = _this4._wrapText(context, label, STUDY_TEXT_MAX_WIDTH - GENE_BACKDROP_PADDING * 4),
            labelLines = _wrapText2.lineArray,
            textWidth = _wrapText2.width;

        var textHeight = labelLines.length * CHAR_HEIGHT;

        var backdropX = scaleX(d.studyId) - textWidth / 2 - GENE_BACKDROP_PADDING;
        var backdropY = scaleY(d.studyId) - GENE_BACKDROP_PADDING;
        var backdropWidth = textWidth + GENE_BACKDROP_PADDING * 2;
        var backdropHeight = textHeight + GENE_BACKDROP_PADDING * 2;

        // picker
        hiddenContext.fillStyle = d.hiddenColor;
        hiddenContext.fillRect(Math.round(backdropX), Math.round(backdropY), Math.round(backdropWidth), Math.round(backdropHeight));

        // backdrop
        context.fillStyle = backgroundColor(d, noSelectedEntities);
        context.strokeStyle = color(d, noSelectedEntities);
        // context.fillStyle = 'white';
        // context.strokeStyle = theme.line.color;
        context.fillRect(backdropX, backdropY, backdropWidth, backdropHeight);
        context.strokeRect(backdropX, backdropY, backdropWidth, backdropHeight);

        // label
        var labelX = scaleX(d.studyId);
        var labelY = scaleY(d.studyId);
        context.textBaseline = 'hanging';
        context.font = '10px sans-serif';
        context.fillStyle = color(d, noSelectedEntities);
        // context.fillStyle = theme.line.color;
        labelLines.forEach(function (l, i) {
          context.fillText(l, labelX, labelY + i * CHAR_HEIGHT);
        });

        // circle
        context.fillStyle = 'white';
        context.strokeStyle = color(d, noSelectedEntities);
        context.beginPath();
        context.arc(scaleX(d.studyId), backdropY, 3, 0, 2 * Math.PI);
        context.fill();
        context.stroke();
      });

      context.restore();
      hiddenContext.restore();
    }
  }, {
    key: '_renderGeneIndexVariantStudies',
    value: function _renderGeneIndexVariantStudies(context, scaleX, scaleStudyX, gTvTrack, tvIvTrack, ivSTrack, data, noSelectedEntities) {
      context.save();

      data.forEach(function (d) {
        context.globalAlpha = 0.3;

        // gene - tagVariantBlock
        {
          var topX = scaleX(d.geneTss);
          var topY = gTvTrack.top;
          var bottomStartX = scaleX(d.tagVariantsStart);
          var bottomEndX = scaleX(d.tagVariantsEnd);
          var isThin = bottomEndX - bottomStartX < 2;
          var bottomY = gTvTrack.bottom;
          var controlY = (bottomY + topY) / 2;
          context.fillStyle = connectorColor(d, noSelectedEntities);
          context.beginPath();
          context.moveTo(topX + 1, topY);
          context.bezierCurveTo(topX + 1, controlY, isThin ? bottomEndX + 1 : bottomEndX, controlY, isThin ? bottomEndX + 1 : bottomEndX, bottomY);
          context.lineTo(isThin ? bottomStartX - 1 : bottomStartX, bottomY);
          context.bezierCurveTo(isThin ? bottomStartX - 1 : bottomStartX, controlY, topX - 1, controlY, topX - 1, topY);
          context.closePath();
          context.fill();
        }

        // tagVariantBlock - indexVariant
        {
          var topStartX = scaleX(d.tagVariantsStart);
          var topEndX = scaleX(d.tagVariantsEnd);
          var _isThin = topEndX - topStartX < 2;
          var _topY = tvIvTrack.top;
          var bottomX = scaleX(d.indexVariantPosition);
          var _bottomY = tvIvTrack.bottom;
          var _controlY = (_bottomY + _topY) / 2;
          context.fillStyle = connectorColor(d, noSelectedEntities);
          context.beginPath();
          context.moveTo(_isThin ? topEndX + 1 : topEndX, _topY);
          context.bezierCurveTo(_isThin ? topEndX + 1 : topEndX, _controlY, bottomX + 1, _controlY, bottomX + 1, _bottomY);
          context.lineTo(bottomX - 1, _bottomY);
          context.bezierCurveTo(bottomX - 1, _controlY, _isThin ? topStartX - 1 : topStartX, _controlY, _isThin ? topStartX - 1 : topStartX, _topY);
          context.closePath();
          context.fill();
        }

        context.globalAlpha = 1;

        // indexVariant - study
        {
          var ivSTopX = scaleX(d.indexVariantPosition);
          var ivSTopY = ivSTrack.top;
          var ivSBottomX = scaleStudyX(d.studyId);
          var ivSBottomY = ivSTrack.bottom;
          var ivSControlY = (ivSBottomY + ivSTopY) / 2;
          context.strokeStyle = connectorColor(d, noSelectedEntities);
          context.beginPath();
          context.moveTo(ivSTopX, ivSTopY);
          context.bezierCurveTo(ivSTopX, ivSControlY, ivSBottomX, ivSControlY, ivSBottomX, ivSBottomY);
          context.stroke();
        }
      });

      context.restore();
    }
  }, {
    key: '_geneSlots',
    value: function _geneSlots(genes, scale) {
      var sortedGenes = _lodash2.default.sortBy(genes.slice(), function (d) {
        return d.start;
      });
      var canvas = this.canvasRef;
      var context = canvas.getContext('2d');

      var slotCount = 0;
      var slots = [];
      var genesWithSlots = [];
      var endOfGene = function endOfGene(gene) {
        var transcriptLength = scale(gene.end) - scale(gene.start);
        var labelLength = context.measureText(gene.symbol + '>').width;
        return transcriptLength > labelLength ? scale.invert(scale(gene.end) + GENE_BACKDROP_PADDING * 3) : scale.invert(scale(gene.start) + labelLength + GENE_BACKDROP_PADDING * 3);
      };
      sortedGenes.forEach(function (gene) {
        var sortedSlots = _lodash2.default.sortBy(slots, function (d) {
          return d.index;
        });
        var suitableSlots = sortedSlots.filter(function (slot) {
          return gene.start > slot.end;
        });
        if (suitableSlots.length > 0) {
          // store in slots
          suitableSlots[0].genes.push(gene);

          // update slot end
          suitableSlots[0].end = endOfGene(gene);

          // store in gene list with slot index
          genesWithSlots.push(_extends({}, gene, { slotIndex: suitableSlots[0].index }));
        } else {
          // store in slots
          var newSlot = {
            genes: [gene],
            end: endOfGene(gene),
            index: slotCount++
          };
          slots.push(newSlot);

          // store in gene list with slot index
          genesWithSlots.push(_extends({}, gene, { slotIndex: newSlot.index }));
        }
      });

      return { slots: slots, genesWithSlots: genesWithSlots };
    }
  }, {
    key: '_tagVariantBlocksSlots',
    value: function _tagVariantBlocksSlots(tagVariantBlocks, scale) {
      var sortedTagVariantBlocks = tagVariantBlocks.slice().sort(function (a, b) {
        return a.tagVariantsStart - b.tagVariantsStart;
      });

      var slotCount = 0;
      var slots = [];
      var tagVariantBlocksWithSlots = [];
      sortedTagVariantBlocks.forEach(function (tagVariantBlock) {
        var suitableSlots = slots.filter(function (slot) {
          return scale(tagVariantBlock.tagVariantsStart) > scale(slot.end);
        });
        if (suitableSlots.length > 0) {
          // store in slots
          suitableSlots[0].tagVariantBlocks.push(tagVariantBlock);
          suitableSlots[0].end = tagVariantBlock.tagVariantsEnd;

          // store in gene list with slot index
          tagVariantBlocksWithSlots.push(_extends({}, tagVariantBlock, {
            slotIndex: suitableSlots[0].index
          }));
        } else {
          // store in slots
          var newSlot = {
            tagVariantBlocks: [tagVariantBlock],
            end: tagVariantBlock.tagVariantsEnd,
            index: slotCount++
          };
          slots.push(newSlot);

          // store in gene list with slot index
          tagVariantBlocksWithSlots.push(_extends({}, tagVariantBlock, {
            slotIndex: newSlot.index
          }));
        }
      });

      return { slots: slots, tagVariantBlocksWithSlots: tagVariantBlocksWithSlots };
    }
  }, {
    key: '_studySlotCount',
    value: function _studySlotCount(studies, width) {
      var studiesPerSlot = Math.floor(width / STUDY_TEXT_MAX_WIDTH) - 1;
      var slotCount = Math.ceil(studies.length / studiesPerSlot);
      return slotCount;
    }
  }, {
    key: '_studiesWithWrappedLabels',
    value: function _studiesWithWrappedLabels(studies, context) {
      var _this5 = this;

      var studiesWithWrappedLabels = studies.map(function (d) {
        var label = d.traitReported + (d.pubAuthor && d.pubDate ? ' (' + d.pubAuthor + ' ' + new Date(d.pubDate).getFullYear() + ')' : '');

        var _wrapText3 = _this5._wrapText(context, label, STUDY_TEXT_MAX_WIDTH - GENE_BACKDROP_PADDING * 4),
            lineArray = _wrapText3.lineArray,
            width = _wrapText3.width;

        return _extends({}, d, {
          wrappedLineArray: lineArray,
          wrappedLineWidth: width
        });
      });
      return studiesWithWrappedLabels;
    }
  }, {
    key: '_studyScaleX',
    value: function _studyScaleX(studies, width) {
      var domain = _lodash2.default.sortBy(studies.slice(), 'meanIndexVariantPosition').map(function (d) {
        return d.studyId;
      });
      var rangeX = [STUDY_TEXT_MAX_WIDTH / 2, width - STUDY_TEXT_MAX_WIDTH / 2];
      var scaleStudyX = d3.scalePoint().domain(domain).range(rangeX);
      return scaleStudyX;
    }
  }, {
    key: '_studyScaleY',
    value: function _studyScaleY(studies, width) {
      var studiesPerSlot = Math.floor(width / STUDY_TEXT_MAX_WIDTH) - 1;
      var slotCount = Math.ceil(studies.length / studiesPerSlot);
      var domain = _lodash2.default.sortBy(studies.slice(), 'meanIndexVariantPosition').map(function (d, i) {
        return _extends({}, d, {
          slotIndex: i % slotCount
        });
      });
      var slots = _lodash2.default.groupBy(domain, function (d) {
        return d.slotIndex;
      });
      var slotHeights = {};
      var slotHeightsCumulative = {};
      var studiesWithSlots = {};
      Object.keys(slots).forEach(function (s) {
        var lineHeightsForSlot = slots[s].map(function (d) {
          return d.wrappedLineArray.length;
        });
        slotHeights[s] = _lodash2.default.max(lineHeightsForSlot);
        slotHeightsCumulative[s] = (s > 0 ? slotHeightsCumulative[s - 1] : 0) + slotHeights[s];
        slots[s].forEach(function (d) {
          studiesWithSlots[d.studyId] = d;
        });
      });

      var top = GENE_TRACK_PADDING + ENTITY_WIDTH;
      var slotIndices = Object.keys(slots);
      var maxSlot = slotIndices[slotIndices.length - 1];
      var trackHeight = top + GENE_TRACK_PADDING + maxSlot * GENE_BACKDROP_PADDING * 6 + slotHeightsCumulative[maxSlot] * CHAR_HEIGHT;
      var rangeY = domain.map(function (d) {
        var s = d.slotIndex;
        return top + s * GENE_BACKDROP_PADDING * 6 + (slotHeightsCumulative[s] - slotHeights[s]) * CHAR_HEIGHT;
      });

      var scaleStudyY = d3.scaleOrdinal().domain(domain.map(function (d) {
        return d.studyId;
      })).range(rangeY);

      return { scaleStudyY: scaleStudyY, trackHeight: trackHeight };
    }
  }, {
    key: '_studyScales',
    value: function _studyScales(studies, width, trackHeight) {
      var studiesPerSlot = Math.floor(width / STUDY_TEXT_MAX_WIDTH) - 1;
      var slotCount = Math.ceil(studies.length / studiesPerSlot);
      // const domain = _.sortBy(studies.slice(), 'traitReported').map(
      //   d => d.studyId
      // );
      var domain = _lodash2.default.sortBy(studies.slice(), 'meanIndexVariantPosition').map(function (d) {
        return d.studyId;
      });
      var rangeX = [STUDY_TEXT_MAX_WIDTH / 2, width - STUDY_TEXT_MAX_WIDTH / 2];
      var rangeY = domain.map(function (d, i) {
        var s = GENE_TRACK_PADDING + ENTITY_WIDTH;
        var e = trackHeight - 2 * GENE_TRACK_PADDING;
        return s + (e - s) * (i % slotCount) / slotCount;
      });
      var scaleStudyX = d3.scalePoint().domain(domain).range(rangeX);
      var scaleStudyY = d3.scaleOrdinal().domain(domain).range(rangeY);

      return { scaleStudyX: scaleStudyX, scaleStudyY: scaleStudyY };
    }
  }, {
    key: '_trackConfig',
    value: function _trackConfig(geneSlotCount, tagVariantBlockSlotCount, studyTrackHeight) {
      var geneTrackHeight = geneSlotCount * GENE_SLOT_HEIGHT + 2 * GENE_TRACK_PADDING;
      var genes = {
        top: LEGEND_HEIGHT,
        bottom: geneTrackHeight + LEGEND_HEIGHT,
        height: geneTrackHeight
      };
      var geneTagVariants = {
        top: genes.bottom,
        bottom: genes.bottom + CONNECTOR_TRACK_HEIGHT,
        height: CONNECTOR_TRACK_HEIGHT
      };
      var tagVariantBlockTrackHeight = tagVariantBlockSlotCount * TAG_VARIANT_BLOCK_SLOT_HEIGHT;
      var tagVariantBlocks = {
        top: geneTagVariants.bottom,
        bottom: geneTagVariants.bottom + tagVariantBlockTrackHeight,
        height: tagVariantBlockTrackHeight
      };
      var tagVariantIndexVariants = {
        top: tagVariantBlocks.bottom,
        bottom: tagVariantBlocks.bottom + CONNECTOR_TRACK_HEIGHT,
        height: CONNECTOR_TRACK_HEIGHT
      };
      var indexVariants = {
        top: tagVariantIndexVariants.bottom,
        bottom: tagVariantIndexVariants.bottom + VARIANT_TRACK_HEIGHT,
        height: VARIANT_TRACK_HEIGHT
      };
      var indexVariantStudies = {
        top: indexVariants.bottom,
        bottom: indexVariants.bottom + CONNECTOR_TRACK_HEIGHT,
        height: CONNECTOR_TRACK_HEIGHT
      };
      // const studyTrackHeight =
      //   (studySlotCount > 0
      //     ? studySlotCount * STUDY_SLOT_HEIGHT
      //     : STUDY_SLOT_HEIGHT) +
      //   2 * GENE_TRACK_PADDING;
      var studies = {
        top: indexVariantStudies.bottom,
        bottom: indexVariantStudies.bottom + studyTrackHeight,
        height: studyTrackHeight
      };
      return {
        genes: genes,
        geneTagVariants: geneTagVariants,
        tagVariantBlocks: tagVariantBlocks,
        tagVariantIndexVariants: tagVariantIndexVariants,
        indexVariants: indexVariants,
        indexVariantStudies: indexVariantStudies,
        studies: studies,
        height: studies.bottom
      };
    }
  }, {
    key: '_wrapText',
    value: function _wrapText(context, text, maxWidth) {
      var textStyle = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : '10px sans-serif';

      if (textStyle) {
        context.font = textStyle;
      }

      var _wrapText4 = wrapText(text, maxWidth, function (str) {
        return context.measureText(str).width;
      }),
          lines = _wrapText4.lines,
          width = _wrapText4.width;

      return { lineArray: lines, width: width };
    }
  }]);

  return Gecko;
}(_react2.default.Component);

exports.default = (0, _reactMeasure.withContentRect)('bounds')(Gecko);