'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _d2 = require('d3');

var d3 = _interopRequireWildcard(_d2);

var _reactMeasure = require('react-measure');

var _theme = require('./theme');

var _theme2 = _interopRequireDefault(_theme);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LEGEND_HEIGHT = 50;
var GENE_SLOT_HEIGHT = 30;
var GENE_TRANSCRIPT_HEIGHT = 7;
var GENE_TRANSCRIPT_OFFSET = 3;
var GENE_BACKDROP_PADDING = 3;
var GENE_TRACK_PADDING = 5;
var STUDY_SLOT_HEIGHT = 50;
var STUDY_TEXT_MAX_WIDTH = 200;
var VARIANT_TRACK_HEIGHT = 7;
var CONNECTOR_TRACK_HEIGHT = 80;
var CHAR_WIDTH = 12; // TODO: base on font-size
var CHAR_HEIGHT = 12;
var HEIGHT_DEFAULT = 400;
var SCALE_FACTOR = 2;
var HIDDEN_TYPE_MAP = {
  gene: 1,
  tagVariant: 2,
  indexVariant: 3,
  study: 4
};
var HIDDEN_TYPE_MAP_INVERSE = {};
Object.keys(HIDDEN_TYPE_MAP).forEach(function (k) {
  return HIDDEN_TYPE_MAP_INVERSE[HIDDEN_TYPE_MAP[k]] = k;
});
var ENTITY_WIDTH = 34;
var ENTITY_RADIUS = 13;

var color = function color(d, noSelectedEntities) {
  return d.selected ? _theme2.default.gecko.colorSelected : !noSelectedEntities && d.chained ? _theme2.default.gecko.colorChained : _theme2.default.gecko.color;
};
var backgroundColor = function backgroundColor(d, noSelectedEntities) {
  return d.selected ? _theme2.default.gecko.backgroundColorSelected : !noSelectedEntities && d.chained ? _theme2.default.gecko.backgroundColorChained : _theme2.default.gecko.backgroundColor;
};
var connectorColor = function connectorColor(d, noSelectedEntities) {
  if (d.posteriorProbability) {
    return d.selected ? _theme2.default.gecko.finemappingConnectorColorSelected : !noSelectedEntities && d.chained ? _theme2.default.gecko.finemappingConnectorColorChained : _theme2.default.gecko.finemappingConnectorColor;
  } else {
    return d.selected ? _theme2.default.gecko.connectorColorSelected : !noSelectedEntities && d.chained ? _theme2.default.gecko.connectorColorChained : _theme2.default.gecko.connectorColor;
  }
};

var Gecko = function (_React$Component) {
  _inherits(Gecko, _React$Component);

  function Gecko(props) {
    _classCallCheck(this, Gecko);

    var _this = _possibleConstructorReturn(this, (Gecko.__proto__ || Object.getPrototypeOf(Gecko)).call(this, props));

    _this.canvasRef = _react2.default.createRef();
    _this.hiddenCanvasRef = _react2.default.createRef();
    return _this;
  }

  _createClass(Gecko, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this._render();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this._render();
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var measureRef = this.props.measureRef;

      var _dimensions2 = this._dimensions(),
          width = _dimensions2.width,
          height = _dimensions2.height;

      return _react2.default.createElement(
        'div',
        {
          ref: measureRef,
          style: {
            width: '100%',
            height: height + 'px',
            position: 'relative'
          }
        },
        _react2.default.createElement('canvas', {
          width: width ? width * SCALE_FACTOR : 0,
          height: height * SCALE_FACTOR,
          style: {
            width: width + 'px',
            height: height + 'px',
            pointerEvents: 'none',
            position: 'absolute',
            top: 0,
            left: 0
          },
          ref: function ref(node) {
            return _this2.canvasRef = node;
          }
        }),
        _react2.default.createElement('canvas', {
          width: width ? width * SCALE_FACTOR : 0,
          height: height * SCALE_FACTOR,
          style: {
            width: width + 'px',
            height: height + 'px',
            position: 'absolute',
            top: 0,
            left: 0,
            imageRendering: 'pixelated',
            opacity: 0
          },
          ref: function ref(node) {
            return _this2.hiddenCanvasRef = node;
          }
        })
      );
    }
  }, {
    key: '_width',
    value: function _width() {
      var contentRect = this.props.contentRect;
      var width = contentRect.bounds.width;

      return width;
    }
  }, {
    key: '_height',
    value: function _height() {
      var _props = this.props,
          data = _props.data,
          start = _props.start,
          end = _props.end;

      var width = this._width();
      if (this._bail(data, width)) {
        return HEIGHT_DEFAULT;
      }
      var scalePosition = d3.scaleLinear().domain([start, end]).range([0, width]);

      var _geneSlots2 = this._geneSlots(data.genes, scalePosition),
          geneSlots = _geneSlots2.slots;

      var studySlotCount = this._studySlotCount(data.studies, width);
      var trackConfig = this._trackConfig(geneSlots.length, studySlotCount);
      return trackConfig.height;
    }
  }, {
    key: '_dimensions',
    value: function _dimensions() {
      var width = this._width();
      var height = this._height();
      return { width: width, height: height };
    }
  }, {
    key: '_bail',
    value: function _bail(data, width) {
      return !width || !data || !data.tagVariants || !data.genes || !data.indexVariants || !data.geneTagVariants || !data.tagVariantIndexVariantStudies || !data.studies;
    }
  }, {
    key: '_render',
    value: function _render() {
      var _props2 = this.props,
          rawData = _props2.data,
          start = _props2.start,
          end = _props2.end,
          showGeneVerticals = _props2.showGeneVerticals,
          handleClick = _props2.handleClick,
          handleMousemove = _props2.handleMousemove,
          selectedGenes = _props2.selectedGenes,
          selectedTagVariants = _props2.selectedTagVariants,
          selectedIndexVariants = _props2.selectedIndexVariants,
          selectedStudies = _props2.selectedStudies;

      var _generateHiddenColors2 = this._generateHiddenColors(rawData),
          colorMap = _generateHiddenColors2.colorMap,
          data = _objectWithoutProperties(_generateHiddenColors2, ['colorMap']);

      var noSelectedEntities = !selectedGenes && !selectedTagVariants && !selectedIndexVariants && !selectedStudies;

      var width = this._width();
      if (this._bail(data, width)) {
        return null;
      }

      var canvas = this.canvasRef;
      var context = canvas.getContext('2d');
      var hiddenCanvas = this.hiddenCanvasRef;
      var hiddenContext = hiddenCanvas.getContext('2d');

      d3.select(hiddenCanvas).on('mousemove', function () {
        var point = d3.mouse(this);

        var _hiddenContext$getIma = _slicedToArray(hiddenContext.getImageData(Math.round(point[0]) * SCALE_FACTOR, Math.round(point[1]) * SCALE_FACTOR, 1, 1).data, 4),
            r = _hiddenContext$getIma[0],
            g = _hiddenContext$getIma[1],
            b = _hiddenContext$getIma[2],
            a = _hiddenContext$getIma[3];

        var color = 'rgb(' + r + ',' + g + ',' + b + ',' + a + ')';
        var item = colorMap[color];
        if (item) {
          var type = HIDDEN_TYPE_MAP_INVERSE[r >> 4];
          d3.select(hiddenCanvas).style('cursor', 'pointer');
          handleMousemove(item, type, point);
        } else {
          d3.select(hiddenCanvas).style('cursor', 'auto');
        }
      });

      d3.select(hiddenCanvas).on('click', function () {
        var point = d3.mouse(this);

        var _hiddenContext$getIma2 = _slicedToArray(hiddenContext.getImageData(Math.round(point[0]) * SCALE_FACTOR, Math.round(point[1]) * SCALE_FACTOR, 1, 1).data, 4),
            r = _hiddenContext$getIma2[0],
            g = _hiddenContext$getIma2[1],
            b = _hiddenContext$getIma2[2],
            a = _hiddenContext$getIma2[3];

        var color = 'rgb(' + r + ',' + g + ',' + b + ',' + a + ')';
        var item = colorMap[color];
        if (item) {
          var type = HIDDEN_TYPE_MAP_INVERSE[r >> 4];
          handleClick(item, type, point);
        }
      });

      var scalePosition = d3.scaleLinear().domain([start, end]).range([0, width]);

      var _geneSlots3 = this._geneSlots(data.genes, scalePosition),
          geneSlots = _geneSlots3.slots,
          genesWithSlots = _geneSlots3.genesWithSlots;

      var studySlotCount = this._studySlotCount(data.studies, width);
      var trackConfig = this._trackConfig(geneSlots.length, studySlotCount);

      var _studyScales2 = this._studyScales(data.studies, width, trackConfig.studies.height),
          scaleStudyX = _studyScales2.scaleStudyX,
          scaleStudyY = _studyScales2.scaleStudyY;

      context.save();
      context.imageSmoothingEnabled = true;
      context.scale(SCALE_FACTOR, SCALE_FACTOR);
      context.clearRect(0, 0, width, trackConfig.height);

      hiddenContext.save();
      hiddenContext.scale(SCALE_FACTOR, SCALE_FACTOR);
      hiddenContext.imageSmoothingEnabled = false;
      hiddenContext.webkitImageSmoothingEnabled = false;
      hiddenContext.mozImageSmoothingEnabled = false;
      hiddenContext.msImageSmoothingEnabled = false;
      hiddenContext.oImageSmoothingEnabled = false;
      hiddenContext.clearRect(0, 0, width, trackConfig.height);

      this._renderLegend(context, width);
      this._renderGenes(context, hiddenContext, scalePosition, trackConfig.genes, genesWithSlots, noSelectedEntities, showGeneVerticals);
      this._renderTagVariants(context, hiddenContext, scalePosition, trackConfig.tagVariants, data.tagVariants, noSelectedEntities);
      this._renderIndexVariants(context, hiddenContext, scalePosition, trackConfig.indexVariants, data.indexVariants, noSelectedEntities);
      this._renderGeneTagVariants(context, scalePosition, trackConfig.geneTagVariants, data.geneTagVariants, noSelectedEntities);
      this._renderStudies(context, hiddenContext, scaleStudyX, scaleStudyY, trackConfig.studies, data.studies, noSelectedEntities);
      this._renderTagVariantIndexVariantStudies(context, scalePosition, scaleStudyX, trackConfig.tagVariantIndexVariants, trackConfig.indexVariantStudies, data.tagVariantIndexVariantStudies, noSelectedEntities);
      this._renderEntities(context, trackConfig, selectedGenes, selectedTagVariants, selectedIndexVariants, selectedStudies);

      context.restore();
      hiddenContext.restore();
    }
  }, {
    key: '_renderEntities',
    value: function _renderEntities(context, trackConfig, selectedGenes, selectedTagVariants, selectedIndexVariants, selectedStudies) {
      context.save();
      context.textAlign = 'center';
      context.textBaseline = 'middle';
      context.lineWidth = 2;

      var x = ENTITY_WIDTH / 2;
      var fill = _theme2.default.grey[300];
      var text = _theme2.default.grey[500];
      var fillFixed = _theme2.default.primary;
      var textFixed = 'white';

      // G
      var yG = trackConfig.genes.top + ENTITY_WIDTH / 2;
      context.fillStyle = selectedGenes ? fillFixed : fill;
      context.strokeStyle = selectedGenes ? fillFixed : text;
      context.beginPath();
      context.arc(x, yG, ENTITY_RADIUS, 0, 2 * Math.PI);
      context.fill();
      context.stroke();
      context.fillStyle = selectedGenes ? textFixed : text;
      context.font = 'bold 12px sans-serif';
      context.fillText('G', x, yG);

      // TV
      var yTV = (trackConfig.tagVariants.top + trackConfig.tagVariants.bottom) / 2;
      context.fillStyle = selectedTagVariants ? fillFixed : fill;
      context.strokeStyle = selectedTagVariants ? fillFixed : text;
      context.beginPath();
      context.arc(x, yTV, ENTITY_RADIUS, 0, 2 * Math.PI);
      context.fill();
      context.stroke();
      context.fillStyle = selectedTagVariants ? textFixed : text;
      context.font = 'bold 12px sans-serif';
      context.fillText('V', x - 2, yTV);
      context.font = 'bold 9px sans-serif';
      context.fillText('T', x + 4, yTV + 5);

      // IV
      var yIV = (trackConfig.indexVariants.top + trackConfig.indexVariants.bottom) / 2;
      context.fillStyle = selectedIndexVariants ? fillFixed : fill;
      context.strokeStyle = selectedIndexVariants ? fillFixed : text;
      context.beginPath();
      context.arc(x, yIV, ENTITY_RADIUS, 0, 2 * Math.PI);
      context.fill();
      context.stroke();
      context.fillStyle = selectedIndexVariants ? textFixed : text;
      context.font = 'bold 12px sans-serif';
      context.fillText('V', x - 2, yIV);
      context.font = 'bold 9px sans-serif';
      context.fillText('L', x + 4, yIV + 5);

      // S
      var yS = trackConfig.studies.top + ENTITY_WIDTH / 2;
      context.fillStyle = selectedStudies ? fillFixed : fill;
      context.strokeStyle = selectedStudies ? fillFixed : text;
      context.beginPath();
      context.arc(x, yS, ENTITY_RADIUS, 0, 2 * Math.PI);
      context.fill();
      context.stroke();
      context.fillStyle = selectedStudies ? textFixed : text;
      context.font = 'bold 12px sans-serif';
      context.fillText('S', x, yS);

      context.restore();
    }
  }, {
    key: '_renderLegend',
    value: function _renderLegend(context, width) {
      context.save();

      context.textAlign = 'start';
      context.textBaseline = 'middle';
      context.font = '12px sans-serif';

      var side = 10;
      var label = LEGEND_HEIGHT / 3;
      var middle = LEGEND_HEIGHT * 2 / 3;
      var top = middle - side / 2;
      var textOffset = 12;
      var itemOffset = 55;
      var groupOffset = 165;
      var textColor = _theme2.default.gecko.color;

      var xDefaultEntity = top;
      var xDefaultConnector = xDefaultEntity + itemOffset;
      var xDefaultConnectorFinemapping = xDefaultConnector + itemOffset;
      var xSelectedEntity = xDefaultConnectorFinemapping + groupOffset;
      var xChainedEntity = xSelectedEntity + groupOffset;
      var xChainedConnector = xChainedEntity + itemOffset;
      var xChainedConnectorFinemapping = xChainedConnector + itemOffset;

      // background
      context.fillStyle = _theme2.default.gecko.legend;
      context.fillRect(0, 0, width, LEGEND_HEIGHT);

      // default entity
      context.fillStyle = _theme2.default.gecko.color;
      context.fillRect(xDefaultEntity, top, side, side);
      context.fillStyle = textColor;
      context.fillText('entity', xDefaultEntity + textOffset, middle);
      // default connector
      context.fillStyle = _theme2.default.gecko.connectorColor;
      context.fillRect(xDefaultConnector, middle - 1, side, 2);
      context.fillStyle = textColor;
      context.fillText('link', xDefaultConnector + textOffset, middle);
      // default connector finemapping
      context.fillStyle = _theme2.default.gecko.finemappingConnectorColor;
      context.fillRect(xDefaultConnectorFinemapping, middle - 1, side, 2);
      context.fillStyle = textColor;
      context.fillText('link (finemapping)', xDefaultConnectorFinemapping + textOffset, middle);

      // selected entity
      context.fillStyle = _theme2.default.gecko.colorSelected;
      context.fillRect(xSelectedEntity, top, side, side);
      context.fillStyle = textColor;
      context.fillText('entity', xSelectedEntity + textOffset, middle);

      // chained entity
      context.fillStyle = _theme2.default.gecko.colorChained;
      context.fillRect(xChainedEntity, top, side, side);
      context.fillStyle = textColor;
      context.fillText('entity', xChainedEntity + textOffset, middle);
      // chained connector
      context.fillStyle = _theme2.default.gecko.connectorColorChained;
      context.fillRect(xChainedConnector, middle - 1, side, 2);
      context.fillStyle = textColor;
      context.fillText('link', xChainedConnector + textOffset, middle);
      // chained connector finemapping
      context.fillStyle = _theme2.default.gecko.finemappingConnectorColorChained;
      context.fillRect(xChainedConnectorFinemapping, middle - 1, side, 2);
      context.fillStyle = textColor;
      context.fillText('link (finemapping)', xChainedConnectorFinemapping + textOffset, middle);

      // labels
      context.textAlign = 'center';
      context.font = 'bold 12px sans-serif';
      context.fillText('unselected', xDefaultConnector + textOffset * 2, label);
      context.fillText('selected', xSelectedEntity + textOffset * 2, label);
      context.fillText('connected', xChainedConnector + textOffset * 2, label);

      context.restore();
    }
  }, {
    key: '_renderGenes',
    value: function _renderGenes(context, hiddenContext, scaleX, track, data, noSelectedEntities, showGeneVerticals) {
      context.save();
      context.translate(0, track.top + GENE_TRACK_PADDING);
      hiddenContext.save();
      hiddenContext.translate(0, track.top + GENE_TRACK_PADDING);

      // verticals
      var verticals = noSelectedEntities || showGeneVerticals ? data : data.filter(function (d) {
        return d.chained;
      });
      verticals.forEach(function (d) {
        context.strokeStyle = color(d, noSelectedEntities);
        context.beginPath();
        context.moveTo(scaleX(d.tss), d.slotIndex * GENE_SLOT_HEIGHT);
        context.lineTo(scaleX(d.tss), track.height - GENE_TRACK_PADDING);
        context.stroke();
      });

      // genes
      data.forEach(function (d) {
        var label = d.start === d.tss ? d.symbol + '>' : '<' + d.symbol;
        var textWidth = context.measureText(label).width;

        var backdropX = scaleX(d.start) - GENE_BACKDROP_PADDING;
        var backdropY = d.slotIndex * GENE_SLOT_HEIGHT + GENE_TRANSCRIPT_OFFSET - GENE_BACKDROP_PADDING;
        var backdropWidth = Math.max(textWidth, scaleX(d.end) - scaleX(d.start)) + GENE_BACKDROP_PADDING * 2;
        var backdropHeight = GENE_TRANSCRIPT_HEIGHT + CHAR_WIDTH + GENE_BACKDROP_PADDING * 2;
        var spitY = d.slotIndex * GENE_SLOT_HEIGHT + GENE_TRANSCRIPT_OFFSET + GENE_TRANSCRIPT_HEIGHT / 2;

        // picker
        hiddenContext.fillStyle = d.hiddenColor;
        hiddenContext.fillRect(backdropX, backdropY, backdropWidth, backdropHeight);

        // backdrop
        context.fillStyle = backgroundColor(d, noSelectedEntities);
        context.strokeStyle = color(d, noSelectedEntities);
        context.fillRect(backdropX, backdropY, backdropWidth, backdropHeight);
        context.strokeRect(backdropX, backdropY, backdropWidth, backdropHeight);

        // spit
        context.beginPath();
        context.moveTo(scaleX(d.start), spitY);
        context.lineTo(scaleX(d.end), spitY);
        context.stroke();

        // exons
        d.exons.forEach(function (e) {
          var exonX = scaleX(e[[0]]);
          var exonY = d.slotIndex * GENE_SLOT_HEIGHT + GENE_TRANSCRIPT_OFFSET;
          var exonWidth = scaleX(e[[1]]) - exonX;
          var exonHeight = GENE_TRANSCRIPT_HEIGHT;
          context.fillRect(exonX, exonY, exonWidth, exonHeight);
          context.strokeRect(exonX, exonY, exonWidth, exonHeight);
        });

        // label
        var labelX = scaleX(d.start);
        var labelY = d.slotIndex * GENE_SLOT_HEIGHT + GENE_TRANSCRIPT_OFFSET * 2 + GENE_TRANSCRIPT_HEIGHT;
        context.textBaseline = 'hanging';
        context.fillStyle = color(d, noSelectedEntities);
        context.fillText(label, labelX, labelY);
      });

      context.restore();
      hiddenContext.restore();
    }
  }, {
    key: '_generateHiddenColors',
    value: function _generateHiddenColors(data) {
      var _this3 = this;

      var genes = data.genes,
          tagVariants = data.tagVariants,
          indexVariants = data.indexVariants,
          studies = data.studies,
          geneTagVariants = data.geneTagVariants,
          tagVariantIndexVariantStudies = data.tagVariantIndexVariantStudies;

      var colorMap = {};
      var genesWithHiddenColor = genes.map(function (d, i) {
        var color = _this3._hiddenColor(i, 'gene');
        colorMap[color] = d;
        return _extends({}, d, { hiddenColor: color });
      });
      var tagVariantsWithHiddenColor = tagVariants.map(function (d, i) {
        var color = _this3._hiddenColor(i, 'tagVariant');
        colorMap[color] = d;
        return _extends({}, d, { hiddenColor: color });
      });
      var indexVariantsWithHiddenColor = indexVariants.map(function (d, i) {
        var color = _this3._hiddenColor(i, 'indexVariant');
        colorMap[color] = d;
        return _extends({}, d, { hiddenColor: color });
      });
      var studiesWithHiddenColor = studies.map(function (d, i) {
        var color = _this3._hiddenColor(i, 'study');
        colorMap[color] = d;
        return _extends({}, d, { hiddenColor: color });
      });
      return {
        colorMap: colorMap,
        genes: genesWithHiddenColor,
        tagVariants: tagVariantsWithHiddenColor,
        indexVariants: indexVariantsWithHiddenColor,
        studies: studiesWithHiddenColor,
        geneTagVariants: geneTagVariants,
        tagVariantIndexVariantStudies: tagVariantIndexVariantStudies
      };
    }
  }, {
    key: '_hiddenColor',
    value: function _hiddenColor(entityId, type) {
      var typeId = HIDDEN_TYPE_MAP[type];
      var r = (typeId << 4) + Math.floor(entityId / 65536) % 256;
      var g = Math.floor(entityId / 256) % 256;
      var b = entityId % 256;
      return 'rgb(' + r + ',' + g + ',' + b + ',255)';
    }
  }, {
    key: '_renderTagVariants',
    value: function _renderTagVariants(context, hiddenContext, scaleX, track, data, noSelectedEntities) {
      context.save();
      hiddenContext.save();

      // picker
      hiddenContext.translate(0, track.top);
      data.forEach(function (d) {
        hiddenContext.fillStyle = d.hiddenColor;
        hiddenContext.fillRect(Math.round(scaleX(d.position)) - 1, 0, 2, Math.round(track.height));
      });

      // backdrop
      context.fillStyle = _theme2.default.track.background;
      context.translate(0, track.top);
      context.fillRect(0, 0, scaleX.range()[1] - scaleX.range()[0], track.height);

      // tag variants
      context.lineWidth = 2;
      data.forEach(function (d) {
        context.strokeStyle = color(d, noSelectedEntities);
        context.beginPath();
        context.moveTo(scaleX(d.position), 0);
        context.lineTo(scaleX(d.position), track.height);
        context.stroke();
      });

      context.restore();
      hiddenContext.restore();
    }
  }, {
    key: '_renderIndexVariants',
    value: function _renderIndexVariants(context, hiddenContext, scaleX, track, data, noSelectedEntities) {
      context.save();
      hiddenContext.save();

      // picker
      hiddenContext.translate(0, track.top);
      data.forEach(function (d) {
        hiddenContext.fillStyle = d.hiddenColor;
        hiddenContext.fillRect(Math.round(scaleX(d.position)) - 1, 0, 2, Math.round(track.height));
      });

      // backdrop
      context.fillStyle = _theme2.default.track.background;
      context.translate(0, track.top);
      context.fillRect(0, 0, scaleX.range()[1] - scaleX.range()[0], track.height);

      // index variants
      context.lineWidth = 2;
      data.forEach(function (d) {
        context.strokeStyle = color(d, noSelectedEntities);
        context.beginPath();
        context.moveTo(scaleX(d.position), 0);
        context.lineTo(scaleX(d.position), track.height);
        context.stroke();
      });

      context.restore();
      hiddenContext.restore();
    }
  }, {
    key: '_renderStudies',
    value: function _renderStudies(context, hiddenContext, scaleX, scaleY, track, data, noSelectedEntities) {
      var _this4 = this;

      context.save();
      context.translate(0, track.top);
      hiddenContext.save();
      hiddenContext.translate(0, track.top);

      // verticals
      data.forEach(function (d) {
        context.strokeStyle = color(d, noSelectedEntities);
        context.beginPath();
        context.moveTo(scaleX(d.studyId), 0);
        context.lineTo(scaleX(d.studyId), scaleY(d.studyId));
        context.stroke();
      });

      // studies
      context.textBaseline = 'hanging';
      context.textAlign = 'center';
      data.forEach(function (d) {
        var label = d.traitReported + (d.pubAuthor && d.pubDate ? ' (' + d.pubAuthor + ' ' + new Date(d.pubDate).getFullYear() + ')' : '');

        var _wrapText2 = _this4._wrapText(context, label, STUDY_TEXT_MAX_WIDTH),
            labelLines = _wrapText2.lineArray,
            textWidth = _wrapText2.width;

        var textHeight = labelLines.length * CHAR_HEIGHT;

        var backdropX = scaleX(d.studyId) - textWidth / 2 - GENE_BACKDROP_PADDING;
        var backdropY = scaleY(d.studyId) - GENE_BACKDROP_PADDING;
        var backdropWidth = textWidth + GENE_BACKDROP_PADDING * 2;
        var backdropHeight = textHeight + GENE_BACKDROP_PADDING * 2;

        // picker
        hiddenContext.fillStyle = d.hiddenColor;
        hiddenContext.fillRect(Math.round(backdropX), Math.round(backdropY), Math.round(backdropWidth), Math.round(backdropHeight));

        // backdrop
        context.fillStyle = backgroundColor(d, noSelectedEntities);
        context.strokeStyle = color(d, noSelectedEntities);
        // context.fillStyle = 'white';
        // context.strokeStyle = theme.line.color;
        context.fillRect(backdropX, backdropY, backdropWidth, backdropHeight);
        context.strokeRect(backdropX, backdropY, backdropWidth, backdropHeight);

        // label
        var labelX = scaleX(d.studyId);
        var labelY = scaleY(d.studyId);
        context.textBaseline = 'hanging';
        context.fillStyle = color(d, noSelectedEntities);
        // context.fillStyle = theme.line.color;
        labelLines.forEach(function (l, i) {
          context.fillText(l, labelX, labelY + i * CHAR_HEIGHT);
        });
      });

      context.restore();
      hiddenContext.restore();
    }
  }, {
    key: '_renderGeneTagVariants',
    value: function _renderGeneTagVariants(context, scaleX, track, data, noSelectedEntities) {
      context.save();
      context.translate(0, track.top);

      // gene tag variants
      data.forEach(function (d) {
        var topX = scaleX(d.geneTss);
        var topY = 0;
        var bottomX = scaleX(d.tagVariantPosition);
        var bottomY = track.height;
        var controlY = (bottomY + topY) / 2;
        context.strokeStyle = connectorColor(d, noSelectedEntities);
        context.beginPath();
        context.moveTo(topX, topY);
        context.bezierCurveTo(topX, controlY, bottomX, controlY, bottomX, bottomY);
        context.stroke();
      });

      context.restore();
    }
  }, {
    key: '_renderTagVariantIndexVariantStudies',
    value: function _renderTagVariantIndexVariantStudies(context, scaleX, scaleStudyX, tvIvTrack, ivSTrack, data, noSelectedEntities) {
      context.save();
      data.forEach(function (d) {
        var tvIvTopX = scaleX(d.tagVariantPosition);
        var tvIvTopY = tvIvTrack.top;
        var tvIvBottomX = scaleX(d.indexVariantPosition);
        var tvIvBottomY = tvIvTrack.bottom;
        var tvIvControlY = (tvIvBottomY + tvIvTopY) / 2;
        var ivSTopX = scaleX(d.indexVariantPosition);
        var ivSTopY = ivSTrack.top;
        var ivSBottomX = scaleStudyX(d.studyId);
        var ivSBottomY = ivSTrack.bottom;
        var ivSControlY = (ivSBottomY + ivSTopY) / 2;

        context.strokeStyle = connectorColor(d, noSelectedEntities);
        context.beginPath();

        // tag variant - index variant
        context.moveTo(tvIvTopX, tvIvTopY);
        context.bezierCurveTo(tvIvTopX, tvIvControlY, tvIvBottomX, tvIvControlY, tvIvBottomX, tvIvBottomY);

        // index variant - study
        context.moveTo(ivSTopX, ivSTopY);
        context.bezierCurveTo(ivSTopX, ivSControlY, ivSBottomX, ivSControlY, ivSBottomX, ivSBottomY);

        context.stroke();
      });
      context.restore();
    }
  }, {
    key: '_geneSlots',
    value: function _geneSlots(genes, scale) {
      var sortedGenes = genes.slice().sort(function (a, b) {
        return a.start - b.start;
      });

      var slotCount = 0;
      var slots = [];
      var genesWithSlots = [];
      sortedGenes.forEach(function (gene) {
        var suitableSlots = slots.filter(function (slot) {
          return scale(gene.start) > scale(slot.end) + gene.symbol.length * CHAR_WIDTH;
        });
        if (suitableSlots.length > 0) {
          // store in slots
          suitableSlots[0].genes.push(gene);
          suitableSlots[0].end = gene.end;

          // store in gene list with slot index
          genesWithSlots.push(_extends({}, gene, { slotIndex: suitableSlots[0].index }));
        } else {
          // store in slots
          var newSlot = { genes: [gene], end: gene.end, index: slotCount++ };
          slots.push(newSlot);

          // store in gene list with slot index
          genesWithSlots.push(_extends({}, gene, { slotIndex: newSlot.index }));
        }
      });

      return { slots: slots, genesWithSlots: genesWithSlots };
    }
  }, {
    key: '_studySlotCount',
    value: function _studySlotCount(studies, width) {
      var studiesPerSlot = Math.floor(width / STUDY_TEXT_MAX_WIDTH);
      var slotCount = Math.ceil(studies.length / studiesPerSlot);
      return slotCount;
    }
  }, {
    key: '_studyScales',
    value: function _studyScales(studies, width, trackHeight) {
      var studiesPerSlot = Math.floor(width / STUDY_TEXT_MAX_WIDTH);
      var slotCount = Math.ceil(studies.length / studiesPerSlot);
      var domain = studies.slice().sort(function (a, b) {
        return a.traitReported - b.traitReported;
      }).map(function (d) {
        return d.studyId;
      });
      var rangeX = [STUDY_TEXT_MAX_WIDTH / 2, width - STUDY_TEXT_MAX_WIDTH / 2];
      var rangeY = domain.map(function (d, i) {
        var s = GENE_TRACK_PADDING + ENTITY_WIDTH;
        var e = trackHeight - 2 * GENE_TRACK_PADDING;
        return s + (e - s) * (i % slotCount) / slotCount;
      });
      var scaleStudyX = d3.scalePoint().domain(domain).range(rangeX);
      var scaleStudyY = d3.scaleOrdinal().domain(domain).range(rangeY);

      return { scaleStudyX: scaleStudyX, scaleStudyY: scaleStudyY };
    }
  }, {
    key: '_trackConfig',
    value: function _trackConfig(geneSlotCount, studySlotCount) {
      var geneTrackHeight = geneSlotCount * GENE_SLOT_HEIGHT + 2 * GENE_TRACK_PADDING;
      var genes = {
        top: LEGEND_HEIGHT,
        bottom: geneTrackHeight + LEGEND_HEIGHT,
        height: geneTrackHeight
      };
      var geneTagVariants = {
        top: genes.bottom,
        bottom: genes.bottom + CONNECTOR_TRACK_HEIGHT,
        height: CONNECTOR_TRACK_HEIGHT
      };
      var tagVariants = {
        top: geneTagVariants.bottom,
        bottom: geneTagVariants.bottom + VARIANT_TRACK_HEIGHT,
        height: VARIANT_TRACK_HEIGHT
      };
      var tagVariantIndexVariants = {
        top: tagVariants.bottom,
        bottom: tagVariants.bottom + CONNECTOR_TRACK_HEIGHT,
        height: CONNECTOR_TRACK_HEIGHT
      };
      var indexVariants = {
        top: tagVariantIndexVariants.bottom,
        bottom: tagVariantIndexVariants.bottom + VARIANT_TRACK_HEIGHT,
        height: VARIANT_TRACK_HEIGHT
      };
      var indexVariantStudies = {
        top: indexVariants.bottom,
        bottom: indexVariants.bottom + CONNECTOR_TRACK_HEIGHT,
        height: CONNECTOR_TRACK_HEIGHT
      };
      var studyTrackHeight = (studySlotCount > 0 ? studySlotCount * STUDY_SLOT_HEIGHT : STUDY_SLOT_HEIGHT) + 2 * GENE_TRACK_PADDING;
      var studies = {
        top: indexVariantStudies.bottom,
        bottom: indexVariantStudies.bottom + studyTrackHeight,
        height: studyTrackHeight
      };
      return {
        genes: genes,
        geneTagVariants: geneTagVariants,
        tagVariants: tagVariants,
        tagVariantIndexVariants: tagVariantIndexVariants,
        indexVariants: indexVariants,
        indexVariantStudies: indexVariantStudies,
        studies: studies,
        height: studies.bottom
      };
    }
  }, {
    key: '_wrapText',
    value: function _wrapText(context, text, maxWidth, textStyle) {
      var splitChar = ' ';
      var wordArray = text.split(splitChar);
      var lineArray = [];
      var lastLine = wordArray[0];
      var width = void 0;
      var measure = 0;
      if (wordArray.length <= 1) {
        width = wordArray.length === 0 ? 0 : context.measureText(wordArray[0]).width;
        return { lineArray: wordArray, width: width };
      }
      if (textStyle) {
        context.font = textStyle;
      }
      for (var i = 1; i < wordArray.length; i++) {
        var w = wordArray[i];
        measure = context.measureText(lastLine + splitChar + w).width;
        if (measure < maxWidth) {
          lastLine += splitChar + w;
        } else {
          lineArray.push(lastLine);
          lastLine = w;
        }
        if (i === wordArray.length - 1) {
          lineArray.push(lastLine);
          break;
        }
      }
      width = lineArray.map(function (l) {
        return context.measureText(l).width;
      }).reduce(function (acc, val) {
        return val > acc ? val : acc;
      }, 0);
      return { lineArray: lineArray, width: width };
    }
  }]);

  return Gecko;
}(_react2.default.Component);

exports.default = (0, _reactMeasure.withContentRect)('bounds')(Gecko);